
/*
 * one line to give the Gauche-archive and an idea of what it does.
 * Copyright (C) 2018 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "archive_class.h"

SCM_DEFINE_BASE_CLASS( Scm_libarchive_archive_baseClass,
                       Scm_libarchive_archive_baseClass, NULL, NULL, NULL,
                       libarchive_archive_base_allocate, NULL );

static ScmObj libarchive_archive_base_allocate( ScmClass *klass,
                                                ScmObj initargs )
{
  Scm_libarchive_archive_base *p = SCM_NEW( Scm_libarchive_archive_base );
  SCM_SET_CLASS( p, SCM_CLASS_LIBARCHIVE_ARCHIVE_BASE );

  p->rw_type  = GAUCHE_ARCHIVE_NONE;
  p->src_type = ARCHIVE_SRC_NONE;
  p->name     = NULL;
  p->buf      = NULL;
  p->buflen   = -1;
  p->obj      = NULL;

  Scm_RegisterFinalizer( SCM_OBJ( p ), libarchive_archive_base_finalize, NULL );

  return SCM_OBJ( p );
}

void libarchive_archive_base_finalize( ScmObj obj, void *data )
{
  Scm_libarchive_archive_base *p = SCM_LIBARCHIVE_ARCHIVE_BASE( obj );

  if( p->obj ) {
    switch( p->rw_type ) {
    case GAUCHE_ARCHIVE_READ:
      archive_read_close( p->obj );
      archive_read_free( p->obj );
      break;

    case GAUCHE_ARCHIVE_WRITE:
      archive_write_close( p->obj );
      archive_write_free( p->obj );
      p->obj = NULL;

    default:
      break;
    }
    p->obj      = NULL;
    p->rw_type  = GAUCHE_ARCHIVE_NONE;
    p->src_type = ARCHIVE_SRC_NONE;
    if( p->name ) {
      free( p->name );
      p->name = NULL;
    }
    p->buf    = NULL;
    p->buflen = -1;
  }
}
